

	.module uart0


	.globl _uart0_interrupt_handler
	.globl _uart0_initialize
	.globl _uart0_get
	.globl _uart0_put

.globl _uart0_rx_queue


_SCON0	=	0x0098
_SBUF0	=	0x0099
_RI0	=	0x0098
_TI0	=	0x0099
_ES0	=	0x00ac


	.area DSEG    (DATA)

_txbusy:
	.ds 1

	.area ISEG    (DATA)

_uart0_tx_queue:
	.ds 10
_uart0_rx_queue:
	.ds 10


	.area CSEG    (CODE)


	ar0 = 0x00
	ar1 = 0x01
	ar2 = 0x02
	ar3 = 0x03
	ar4 = 0x04
	ar5 = 0x05
	ar6 = 0x06
	ar7 = 0x07



_uart0_interrupt_handler:
	push	acc
	push	b
	push	dpl
	push	dph
	push	ar0
	push	ar1
	push	ar2
	push	ar3
	push	ar4
	push	ar5
	push	ar6
	push	ar7
	push	psw
	mov	psw,#0x00
00110$:
	jnb  _TI0,00107$
00118$:
	clr	_TI0
	mov	_txbusy,#0x00
	mov dptr,#_uart0_tx_queue
	lcall	q8get
	jc	00110$
00119$:
	mov	_SBUF0,a
	mov	_txbusy,#0x01
	sjmp 00110$

00107$:
	jnb  _RI0,00112$
00120$:
	clr	_RI0
	mov	a,_SBUF0
	mov	dptr,#_uart0_rx_queue
	lcall	q8put
	sjmp 00110$

00112$:
	pop	psw
	pop	ar7
	pop	ar6
	pop	ar5
	pop	ar4
	pop	ar3
	pop	ar2
	pop	ar1
	pop	ar0
	pop	dph
	pop	dpl
	pop	b
	pop	acc
	reti






_uart0_get:
	clr	_ES0
	mov	dpl,#_uart0_rx_queue
	lcall q8get
	mov dptr,#0xffff
	jc _uart0_get_0

	mov dpl,a
	mov dph,#0
_uart0_get_0:
	setb _ES0
	ret




_uart0_put:
	clr	_ES0

	mov	a,dpl
	mov	dpl,#_uart0_tx_queue
	lcall q8put
	mov	a,_txbusy
	jnz _uart0_put_0

	lcall q8get
	jc _uart0_put_0

	mov	_SBUF0,a
	mov	_txbusy,#1
	clr	_TI0

_uart0_put_0:
	setb _ES0
	ret




_uart0_initialize:
	push ar0

	mov r0,#_uart0_tx_queue
	mov @r0,#0
	inc r0
	mov @r0,#0

	mov r0,#_uart0_rx_queue
	mov @r0,#0
	inc r0
	mov @r0,#0

	mov	_txbusy,#0

	mov	_SCON0,#0x50
	clr	_RI0
	clr	_TI0
	setb _ES0

	pop ar0
	ret



	.area CSEG    (CODE)

